lib = File.expand_path('lib', __dir__)
$LOAD_PATH.unshift(lib) unless $LOAD_PATH.include?(lib)
require 'git/switcher/version'

Gem::Specification.new do |spec|
  spec.name          = Git::Switcher::NAME
  spec.version       = Git::Switcher::VERSION
  spec.authors       = ['Peter Vandenberk']
  spec.email         = ['pvandenberk@mac.com']

  spec.summary       = 'The ultimate CLI git branch and tag switcher'
  spec.description   = 'Easily switch between git tags and branches'
  spec.homepage      = 'https://github.com/pvdb/git-switcher'
  spec.license       = 'MIT'

  spec.files         = Dir.chdir(File.expand_path(__dir__)) do
    `git ls-files -z`
      .split("\x0")
      .reject { |f| f.match(%r{^(test|spec|features)/}) }
  end
  spec.bindir        = 'exe'
  spec.executables   = spec.files.grep(%r{^exe/}) { |f| File.basename(f) }
  spec.require_paths = ['lib']

  spec.add_dependency 'rainbow', '~> 3.0'
  spec.add_dependency 'rugged', '~> 0.27'

  spec.add_development_dependency 'bundler'
  spec.add_development_dependency 'minitest'
  spec.add_development_dependency 'pry'
  spec.add_development_dependency 'pry-rescue'
  spec.add_development_dependency 'rake'
  spec.add_development_dependency 'rubocop'
end
